#!/bin/bash
#2021/07/06 v1.0
# Автор Мамзиков Артём Андреевич Описание по скрипту
# Получение списка Интерфейсов Windows которые в статусе подключены или находятся в папке Сетевые подключения

#./net.if.sh 192.168.xxx.xx 10050 discovery , ключ net.if.sh[{HOST.CONN},{HOST.PORT},discovery]
# {HOST.HOST} -Имя узла сети; {HOST.CONN} -IP адрес или DNS имя узла сети; {HOST.PORT} -Порт узла сети (агента)

if [[ $3 = "discovery" ]]
then

# Запрос Сетевых интерфейсов
get=`zabbix_get -s $1 -p $2 -k system.run["netsh interface show interface"]`

#Убрать первые 3 строки|Если коректно не отображается русский перекодируем из cp866 в utf8 или cp1251 в utf8|выбираем включенный|добавление табуляции от 3х пробелов|выводим последний столбец название адаптера|удалить пустую строку|удалить перенос каретки
kodr=$(echo "${get}"|tail -n +4|iconv -f cp866 -t utf8|sed -n '/Connected \|подключен \|enabled \|включен /Ip'|sed -E 's/   ([^ ])/\t\1/g; s/^1/1\t/;'|awk -F\\t '{print $4}'|sed -e '/^$/d'|tr -d '\r')
kodir=$(echo "${get}"|tail -n +4|iconv -f cp1251 -t utf8|grep -i -E -w "Connected|Подключен|enabled|включен"|sed -E 's/   ([^ ])/\t\1/g; s/^1/1\t/;'|awk -F\\t '{print $4}'|sed -e '/^$/d'|tr -d '\r')
#echo "${kodr}"
#echo "${kodir}"

# Текущие настройки протокола TCP/IP
info=`zabbix_get -s $1 -p $2 -k system.run["ipconfig /all"]`

# Получаем описание|меняем кодировку|находим строку и выводим еще 4 ниже|выбираем 1 строку|Обрезаем все лишнее
NAME=$(echo "${info}"|iconv -f cp866 -t utf8|grep -i -A 4 -E -w "${kodr}":|grep -i -E -w "Описание.|Description."|sed 's|.*. : ||')
NAMEP=$(echo "${info}"|iconv -f cp1251 -t utf8|grep -i -A 4 -E -w "${kodr}":|grep -i -E -w "Описание.|Description."|sed 's|.*. : ||')
#echo "${NAME}"
#echo "${NAMEP}"

# Список Интерфейсов| подставить макрос| закрытие скобки| удаление табуляции и переноса строк| удаление последней запятой| Сделаем читаемый вид
obr=`echo "${NAME}"| sed 's/^/\t{\"{#IFNAME}\":\"/'| sed 's/.$/\"},/'| tr -d '\t\n'| sed 's/,\+$//'| sed 's/\.*"},/"},\n/g'`
obrp=`echo "${NAMEP}"| sed 's/^/\t{\"{#IFNAME}\":\"/'| sed 's/.$/\"},/'| tr -d '\t\n'| sed 's/,\+$//'| sed 's/\.*"},/"},\n/g'`

# Проверка правильного декодирования, по параметру что чтрока не пустая
# Если данные есть выводим их CP866
if [ -n "${kodr}" ]; then NAMELAN="${obr}"
# Если данные есть выводим их CP1251
elif [ -n "${kodir}" ]; then NAMELAN="${obrp}"
fi

# Формируе Вывод
JSON="{\"data\":[\n""${NAMELAN}""\n]}"
fi
echo -e "${JSON}"